<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement Systempay
#						Version : 2.6 (rvision 21960)
#									########################
#					Dvelopp pour VirtueMart
#						Version : 1.1.4
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						21/12/2010
#						Contact : supportvad@lyra-network.com
#
#####################################################################################################

if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );

/*
 * Load payment module
 */
require_once(  CLASSPATH ."payment/ps_vads.cfg.php");
require_once(  CLASSPATH ."payment/ps_vads.php");

global $mosConfig_lang;
$VADS_LANG =& new ps_VADS_LANG();
$ps_vads = new ps_vads();
$vads_api=new VADS_API();

/*
 * Gather payment data
 */
$amount = round($db->f("order_total" ),2) * 100;

$dbbt = new ps_DB;

$qt = "SELECT * FROM #__{vm}_user_info WHERE user_id=".$auth["user_id"]." AND address_type='BT'";

$dbbt->query($qt);
$dbbt->next_record();
$user_info_id = $dbbt->f("user_info_id");

$db_country =& new ps_DB;
$sql = "SELECT country_2_code FROM #__{vm}_country WHERE country_3_code='".$dbbt->f('country')."'";
$db_country->query($sql);
$db_country->next_record();
$country = $db_country->f('country_2_code');

// Convert from virtuemart language name to standard 2 letters iso code
$converted_langs = array(
	'german' => 'de',
	'germanf' => 'de',
	'germani' => 'de',
	'english' => 'en',
	'simplified_chinese' => 'zh',
	'traditional_chinese' => 'zh',
	'spanish' => 'es',
	'french' => 'fr',
	'italian' => 'it',
	'japanese' => 'ja'
);

if( array_key_exists($mosConfig_lang, $converted_langs) )
	$langage = $converted_langs[$mosConfig_lang];
else
	$langage = VADS_LANGAGE_DEFAUT;

// Convert from virtuemart currency to numeric ISO code
$currency_alpha3 = $_SESSION['vendor_currency'];
$currency_num = $vads_api->convertAlphaCurrency($currency_alpha3);
if(!$currency_num) {
	// currency not recognised, use default
	$currency_num = VADS_MONNAIE;
}
	
/*
 * Build the request
 */
$vads_api->set('platform_url',				VADS_LIEN_BANQUE);
$vads_api->set('version',					'V1');
$vads_api->set('contrib',					'VirtueMart1.1.4_2.6');
$vads_api->set('key_test',					VADS_KEY_TEST);
$vads_api->set('key_prod',					VADS_KEY_PROD);
$vads_api->set('amount',		 			$amount);
$vads_api->set('capture_delay',		 		VADS_DELAY);
$vads_api->set('currency',		 			$currency_num);
$vads_api->set('cust_email',				$dbbt->f('user_email'));
$vads_api->set('ctx_mode',					VADS_MODE);
$vads_api->set('payment_cards',				VADS_CARTE_DISPO);
$vads_api->set('payment_config',			VADS_TYPE_PAIEMENT);
$vads_api->set('site_id',					VADS_SITE_ID);
$vads_api->set('validation_mode',			VADS_TYPE_VALIDATION);
$vads_api->set('cust_id',					$dbbt->f('user_id'));
$vads_api->set('cust_name',					$dbbt->f('last_name').' '.$dbbt->f('first_name'));
$vads_api->set('cust_address',				$dbbt->f('address_1') . " " . $dbbt->f('address_2'));
$vads_api->set('cust_zip',					$dbbt->f('zip'));
$vads_api->set('cust_city',					$dbbt->f('city'));
$vads_api->set('cust_country',				$country);
$vads_api->set('language',					$langage);
$vads_api->set('order_id',					$db->f("order_id" ));
$vads_api->set('url_return',				VADS_URL_DEFAUT);
$vads_api->set('return_mode',				VADS_RETURN_MODE);
$vads_api->set('redirect_enabled',			VADS_REDIRECT_ENABLED);
$vads_api->set('redirect_success_timeout',	VADS_REDIRECT_SUCCESS_TIMEOUT);
$vads_api->set('redirect_success_message',	VADS_REDIRECT_SUCCESS_MESSAGE);
$vads_api->set('redirect_error_timeout',	VADS_REDIRECT_ERROR_TIMEOUT);
$vads_api->set('redirect_error_message',	VADS_REDIRECT_ERROR_MESSAGE);

/*
 * Redirect client
 */
if( $page == "checkout.thankyou" )
{
/* Mthode alternative  tester : cacher la page et soumettre le formulaire aprs chargement (adaptation google analytics)
<script language="javascript">
	// Hide the page
	document.body.style.display="none";
	
	// Go to payment page
	var vads_form_submit = function() { document.forms["vads_form"].submit(); };
	
	if(window.addEventListener) {// W3C event handling
		window.addEventListener('load',vads_form_submit,false);
	}
	else if(window.attachEvent) {	// Microsoft event handling
		window.attachEvent('onload',vads_form_submit);
	}
	else {							// Old event handling
		window.onload = vads_form_submit;
	}
</script>
//*/
	vmRedirect( $vads_api->getRequestUrl() );
}
else
{
	echo $vads_api->getRequestHtmlForm('id="vads_form"','hidden', $VADS_LANG->_("GOTO_PAYMENT_GATEWAY"), 'name="submit"');
}

?>