<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement Systempay
#						Version : 2.6 (rvision 21960)
#									########################
#					Dvelopp pour VirtueMart
#						Version : 1.1.4
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						21/12/2010
#						Contact : supportvad@lyra-network.com
#
#####################################################################################################

/*
 * Traitement de la confirmation de paiement serveur  serveur
 */
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );

// Chargement du module appropri
require_once(CLASSPATH . 'ps_order.php' );
if(stripos($_POST['payment_config'],'MULTI') !== false || stripos($_POST['contrib'],'multi') !== false)
{
	$prefix = 'VADS_MULTI_';
	require_once(CLASSPATH . 'payment/ps_vads_multi.cfg.php');
	require_once(CLASSPATH . 'payment/ps_vads_multi.php');

	$VADS_LANG =& new ps_VADS_MULTI_LANG();
	$ps_vads = new ps_vads_multi();
	$vads_api = new VADS_MULTI_API();
}
else {
	$prefix = 'VADS_';
	require_once(CLASSPATH . 'payment/ps_vads.cfg.php');
	require_once(CLASSPATH . 'payment/ps_vads.php');
	
	$VADS_LANG =& new ps_VADS_LANG();
	$ps_vads = new ps_vads();
	$vads_api = new VADS_API();
}

$vads_api->setResponseFromPost($_POST, constant($prefix.'KEY_TEST'), constant($prefix.'KEY_PROD'), constant($prefix.'MODE'));

// Filtrage des tentatives de fraude
if( ! $vads_api->isAuthentifiedResponse() )
{
	echo $vads_api->getCheckUrlResponse('auth_fail');
	die();
}

// La commande a-t-elle dj t enregistre ?
$db = new ps_DB();
$order_id = $db->getEscaped(vmGet($_REQUEST, "order_id" ));
$db->query( 'SELECT order_status_code FROM #__{vm}_order_history WHERE order_id='.$order_id.' ORDER BY date_added DESC' );
$db->next_record();
$order_not_confirmed = (!$db || $db->f('order_status_code')=='P');
$order_canceled = ($db && $db->f('order_status_code')=='X');

// Traitement selon le cas
if($order_canceled)
{
	die( $vads_api->getCheckUrlResponse('ko',"La commande est annule"));
}

// Traitement selon le cas
if($order_not_confirmed)
{
	// Commande en attente de paiement
	if($vads_api->isAcceptedPayment())
	{
		// Confirmation de la plateforme
		// On valide la commande
		$ps_vads->update_order($vads_api, constant($prefix.'VERIFIED_STATUS'));
		// On affiche un code de confirmation
		echo $vads_api->getCheckUrlResponse('payment_ok');
	}
	else
	{
		// On ajoute un historique et on change ventuellement le statut de la commande
		$ps_vads->update_order($vads_api, constant($prefix.'INVALID_STATUS'));
		
		// Paiement invalide notifi par la plateforme
		echo $vads_api->getCheckUrlResponse('payment_ko');
	}
}
else
{
	// Commande dj accepte
	if($vads_api->isAcceptedPayment())
	{
		echo $vads_api->getCheckUrlResponse('payment_ok_already_done');
	}
	else
	{
		echo $vads_api->getCheckUrlResponse('payment_ko_on_order_ok');
	}
}
?>