<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement Systempay
#						Version : 2.6 (rvision 21960)
#									########################
#					Dvelopp pour VirtueMart
#						Version : 1.1.4
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						21/12/2010
#						Contact : supportvad@lyra-network.com
#
#####################################################################################################

/*
 * Traitement du retour du client sur la boutique
 */
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );

// Chargement du module appropri
require_once(CLASSPATH . 'ps_order.php' );
if(stripos($_REQUEST['payment_config'],'MULTI') !== false || stripos($_REQUEST['contrib'],'multi') !== false)
{
	$prefix = 'VADS_MULTI_';
	require_once(CLASSPATH . 'payment/ps_vads_multi.cfg.php');
	require_once(CLASSPATH . 'payment/ps_vads_multi.php');

	$VADS_LANG =& new ps_VADS_MULTI_LANG();
	$ps_vads = new ps_vads_multi();
	$vads_api = new VADS_MULTI_API();
	$vads_api->setResponseFromPost($_REQUEST, VADS_MULTI_KEY_TEST, VADS_MULTI_KEY_PROD, VADS_MULTI_MODE);
}
else {
	$prefix = 'VADS_';
	require_once(CLASSPATH . 'payment/ps_vads.cfg.php');
	require_once(CLASSPATH . 'payment/ps_vads.php');

	$VADS_LANG =& new ps_VADS_LANG();
	$ps_vads = new ps_vads();
	$vads_api = new VADS_API();
	$vads_api->setResponseFromPost($_REQUEST, VADS_KEY_TEST, VADS_KEY_PROD, VADS_MODE);
}


$url_order_history = URL."index.php?page=account.index&option=com_virtuemart&Itemid=1";

// Filtrage des tentatives de fraude
if( ! $vads_api->isAuthentifiedResponse() )
{
	vmRedirect(URL."index.php?option=com_virtuemart&page=shop.cart");
	die();
}

// La commande a-t-elle dj t enregistre ?
$db = new ps_DB();
$order_id = $db->getEscaped(vmGet($_REQUEST, "order_id" ));
$db->query( 'SELECT order_status_code FROM #__{vm}_order_history WHERE order_id='.$order_id.' ORDER BY date_added DESC' );
$db->next_record();
$order_not_confirmed = (!$db || $db->f('order_status_code')=='P');
$order_canceled = ($db && $db->f('order_status_code')=='X');

// Traitement selon le cas
if($order_canceled)
{
	echo '<h2>'.$VADS_LANG->_('PS_VADS_ERREUR_PAIEMENT').'</h2>';
	echo '<h3><a href="'.$url_order_history.'">'.$VADS_LANG->_('PS_VADS_RETURN_TO_ORDERS_HISTORY').'</a></h3>';
}
elseif($order_not_confirmed)
{
	// Commande en attente de paiement
	if($vads_api->isAcceptedPayment())
	{
		// On valide la commande
		$ps_vads->update_order($vads_api, constant($prefix.'VERIFIED_STATUS'));
		
		// L'url serveur n'a pas fonctionn, on affiche un avertissement en mode test
		if( $vads_api->get('ctx_mode')=='TEST' )
			echo '<span style="color:red">'.$VADS_LANG->_('PS_VADS_IS_CHECK_URL_FILLED').'</span>';
		
		// Message de confirmation
		echo '<h2>'.$VADS_LANG->_('PS_VADS_THANKYOU').'</h2>';
		echo '<p><a href="index.php?option=com_virtuemart&page=account.order_details&order_id='.$vads_api->get('order_id').'">';
		echo $VM_LANG->_('_PHPSHOP_ORDER_LINK');
		echo '</a></p>';
	}
	else
	{
		// Retour du client aprs chec du processus de paiement => mj + message + lien vers l'historique des commandes
		$ps_vads->update_order($vads_api, constant($prefix.'INVALID_STATUS'));
		
		echo '<h2>'.$VADS_LANG->_('PS_VADS_ERREUR_PAIEMENT').'</h2>';
		echo '<h3><a href="'.$url_order_history.'">'.$VADS_LANG->_('PS_VADS_RETURN_TO_ORDERS_HISTORY').'</a></h3>';
		//vmRedirect('index.php?page=account.index&option=com_virtuemart');
	}
}
else
{
	// Commande dj accepte
	if($vads_api->isAcceptedPayment())
	{
		echo '<h2>'.$VADS_LANG->_('PS_VADS_THANKYOU').'</h2>';
		echo '<p><a href="index.php?option=com_virtuemart&page=account.order_details&order_id='.$vads_api->get('order_id').'">';
		echo $VM_LANG->_('_PHPSHOP_ORDER_LINK');
		echo '</a></p>';
	}
	else
	{
		// Erreur ! Rception d'un paiement invalide pour une commande dj enregistre
		$message  = '<span style="color:red">';
		$message .= $VADS_LANG->_('PS_VADS_ERROR');
		$message .= '</span>';
		echo $message;
	}
}
?>